// Divoka postupnost
// Autor: Peter Trebaticky
//
// Opis algoritmu:
//  Mame tri ukazovatele do pola 'postupnost'. Najprv vsetky ukazuju na
//  zaciatok. Ukazovatel 'a' sluzi pre predpis x*x, ukazovatel 'b' pre 5x-2
//  a ukazovatel 'c' pre 2x+1. Zistime minimum z vypocitanych hodnot pri
//  dosadeni postupnost[a], postupnost[b], resp. postupnost[c]. Toto minimum
//  pridame k postupnosti a zvysime prislusny ukazovatel o 1.
//  Treba davat pozor na opakujuce sa cisla.
#include <stdio.h>

#define NOdebug

#define MAX 10001

FILE *fin,*fout;
long postupnost[MAX],k,min;
int a,b,c,indmax;

long funca(){
  return 2*postupnost[a]+1;
}

long funcb(){
  return 5*postupnost[b]-2;
}

long funcc(){
  return postupnost[c]*postupnost[c];
}

void main(void){
#ifdef debug
  fin=fopen("wild.in","rt");
  fout=fopen("wild.out","wt");
#else
  fin=stdin;
  fout=stdout;
#endif

  fscanf(fin,"%ld",&k);
  postupnost[0]=1;
  postupnost[1]=3;
  a=1;b=1;c=1;indmax=1;

  while(k!=-1){
    if(k<indmax)// ak uz k-ty clen mame, netreba ho pocitat znovu
     fprintf(fout,"%lu\n",postupnost[k]);
      else{
        while(indmax<k){
          do{
            min=funca();
            a++; // predpokladam, ze funca() je minimum
            if(funcb()<min){
              min=funcb();
              a--;// funca() nie je minimum
              b++;// predpokladam, ze funcb() je minimum
            }
            if(funcc()<min){
              min=funcc();
              a--;// funca() nie je minimum (nevadi, ak 'a' znizim dva krat)
              b--;// funcb() nie je minimum
              c++;// funcc() je minimum
            }
          } while(min<=postupnost[indmax]);// nezapisujeme opakujuce sa cisla

          postupnost[++indmax]=min;
        }

        fprintf(fout,"%lu\n",postupnost[k]);
      }
    fscanf(fin,"%ld",&k);
  }

#ifdef debug
  fclose(fout);
  fclose(fin);
#endif
}